
public class TipiPrimitivi{

	public static void main(String Args[]){
					
		//Numeri interi (rappresentazione in complemento a due, diversa precisione)
		byte b=10;				//8-bit
		short s=10;				//16-bit
		int i=10;				//32-bit
		long l=10;				//64-bit
		
		//Numeri reali (rappresentazione mantissa+esponente, virgola mobile)
		float f=0.5f;					//precisione singola (32bit)
		double d=0.5;					//precisione doppia (64 bit)
		
		
		/*
			Le costanti numeriche vengono riconosciute come segue:
		
				numero senza virgola --> int
				numero con la virgola --> double
		
			Per indicare esplicitamente che una costante  
		
				float 	si aggiunge F in coda
				long 	si aggiunge L in coda
				double 	si aggiunge D in coda
		*/	
		
		
		//Durante un'assegnazione o inizializzazione possono avvenire conversioni
		//di tipo implicite. E' sempre possibile passare ad un tipo con maggiore precisione
		
		//Es:
		l=b;
		
		//Se invece si cerca di passare ad un tipo con minore precisione:
		//s=l il compilatore avverte: possible loss of precision.
		
		//Questo avviene se il compilatore non pu verificare staticamente il valore 
		//che viene passato. Se invece pu farlo, come nel caso delle costanti, 
		//si ottiene un errore solo nel caso in cui la costante sia effettivamente fuori range
		
		//Es:
		b=100; 	//ok
		//b=1000; //possible loss of precision, i byte vanno da -127 a +128
		
		//l=1000000000000000;	//integer number too large
		l=1000000000000000L;		
		
		
		//altri tipi
		char c='a';					//caratteri (singoli)
		boolean bool=true;			//true/false


		//note: le costanti carattere si scrivono tra apici es: 'a'. 
		//I doppi apici indicano costanti del tipo (non primitivo) String.



		//il tipo delle variabili vincola il tipo dei valori 
		//che possono essere assegnati loro.
		
		//i=true;       //incompatyble types

 		
 		System.out.println(b);
 		System.out.println(s);
 		System.out.println(i);
 		System.out.println(l);
 		System.out.println(f);
 		System.out.println(d);
 		System.out.println(c);
 		System.out.println(bool);
    }
}


